//+------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"



#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Gold
#property indicator_color3 Silver
#property indicator_color4 Aqua
#property indicator_color5 Magenta
#property indicator_color6 White
#property indicator_color7 Red
#property indicator_color8 Blue


#property indicator_level1 0.0
#property indicator_level2 0.1
#property indicator_level3 -0.1
#property indicator_level4 0.5
#property indicator_level5 -0.5
#property indicator_level6 0.8
#property indicator_level7 -0.8


//extern string ________Long_Symbols________ = "";                    

string     Symb1          = "#HPQ";
string     Symb2          = "#IBM";
string     Symb3          = "#INTC";
string     Symb4          = "#MSFT";
string     Symb5          = "#QQQ";
string     Symb6          = "#SPY";
string     Symb7          = "#T";
string     Symb8          = "#XOM";
string     Symb9          = "#DIA";
string     Symb10          = "#AA";
string     Symb11          = "#AIG";
string     Symb12          = "#AXP";
string     Symb13          = "#BA";
string     Symb14          = "#C";
string     Symb15          = "#CAT";
string     Symb16          = "#DD";
string     Symb17          = "#DIS";
string     Symb18          = "#EK";
string     Symb19          = "#GE";
string     Symb20          = "#GM";
string     Symb21          = "#HD";
string     Symb22          = "#HON";
string     Symb23          = "#IP";
string     Symb24          = "#JNJ";
string     Symb25          = "#JPM";
string     Symb26          = "#KO";
string     Symb27          = "#MCD";
string     Symb28          = "#MMM";
string     Symb29          = "#MO";
string     Symb30          = "#MRK";
string     Symb31          = "#PFE";
string     Symb32          = "#PG";
string     Symb33          = "#UTX";
string     Symb34          = "#VZ";
string     Symb35          = "#WMT";
string     Symb36          = "#CZ7";
string     Symb37          = "#WZ7";
string     Symb38          = "#SX7";
string     Symb39          = "#QMX7";
string     Symb40          = "#QGX7";
string     Symb41          = "#ESZ7";
string     Symb42          = "#NQZ7";
string     Symb43          = "#GCZ7";
string     Symb44          = "#SIZ7";

/*
string     Symb1          = "SAMAG";	//Advanced Magn.
string     Symb2          = "SAEPI";	//AEP Ind.
string     Symb3          = "SALB";	   //Albemarle Corp.
string     Symb4          = "SADS";	   //Alliance Data System
string     Symb5          = "SALTH";	//Allos Therap.
string     Symb6          = "SAXR";	   //Amrep
string     Symb7          = "SAAPL";	//Apple Comp.
string     Symb8          = "SAVP";	   //Avon Prod.
string     Symb9          = "SBIDU";	//Baidu.com
string     Symb10         = "SBAC";	   //Bank Of America
string     Symb11         = "SBA";	   //Boeing Co.
string     Symb12         = "SBAB";	   //British Airways
string     Symb13         = "SBRCD";	//Brocade Comm.
string     Symb14         = "SCSH";	   //Cash America Int.
string     Symb15         = "SBOT";	   //CBOT Hold.
string     Symb16         = "SCVX";	   //Chevron
string     Symb17         = "SCSCO";	//Cisco Systems
string     Symb18         = "SCAL";	   //Continental Airlines
string     Symb19         = "SCOH";	   //Coach Inc.
string     Symb20         = "SCTSH";	//Cognizant Techn. 
string     Symb21         = "SCAL";	   //Cont. Airline
string     Symb22         = "SCPA";	   //Copa Holdings SA
string     Symb23         = "SCRAY";	//Cray Inc.
string     Symb24         = "SCS";	   //Credit Suisse
string     Symb25         = "SCROX";   //Crocs Inc.
string     Symb26         = "SDAKT";	//Daktronics
string     Symb27         = "SDIVX";	//DivX Inc.
string     Symb28         = "SXOM";	   //Exxon
string     Symb29         = "SGD";	   //General Dynamics Corp.
string     Symb30         = "SGM";	   //General Motors
string     Symb31         = "SGLDN";	//Golden Teleccom
string     Symb32         = "SGS";	   //Goldman Sachs
string     Symb33         = "SGT";	   //GoodYear Tire
string     Symb34         = "SGOOG";	//Google
string     Symb35         = "SGES";	   //Guess ? Inc.
string     Symb36         = "SHPQ";	   //Hewlett Packard
string     Symb37         = "SICOC";	//ICO Inc.
string     Symb38         = "SIIG";	   //Imergent Inc.
string     Symb39         = "SQQQQ";	//Index NASDAQ
string     Symb40         = "SINFY";	//Infosys Techn.
string     Symb41         = "SJSDA";	//Jones Soda
string     Symb42         = "SLVS";	   //Las Vegas Sands
string     Symb43         = "SLMT";	   //Lockheed Martin
string     Symb44         = "SMA";	   //Master Card
string     Symb45         = "SMSFT";	//Microsoft
string     Symb46         = "SMS";	   //Morgan Stanley
string     Symb47         = "SNDAQ";	//Nasdaq Stock
string     Symb48         = "SNENG";	//Network Eng.
string     Symb49         = "SNTRI";	//Nutri Systems
string     Symb50         = "SNVDA";	//Nvidia
string     Symb51         = "SNYX";	   //NYSE Groupe
string     Symb52         = "SPOT";	   //Potash Corp.
string     Symb53         = "SRIMM";	//Research In Motion Ltd
string     Symb54         = "SSOFO";	//Sonic Foundry
string     Symb55         = "STRA";	   //Terra Ind.
string     Symb56         = "STXI";	   //Texas Ind.
string     Symb57         = "STM";	   //Toyota Motor
string     Symb58         = "SGROW";	//US Global Investors
string     Symb59         = "SWBD";	   //Wimm Bill Dann
*/	


//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Buffer8[];

//---
extern int n=8; //  
extern int Fmin=2;//2; //    .
extern int Fmax=128; //    .
extern int pearson_per=5;
//extern string sym="GBPUSD";
//extern string sym="EURUSD";
double aa0[];
double aa0_1[];
double aa0_2[];
double aa0_3[];
double aa0_4[];
double aa0_5[];
double aa0_6[];
double aa0_7[];
double aa0_8[];
double aa0_9[];
double aa0_10[];
double aa0_11[];
double aa0_12[];
double aa0_13[];
double aa0_14[];
double aa0_15[];
double aa0_16[];
double aa0_17[];
double aa0_18[];
double aa0_19[];
double aa0_20[];
double aa0_21[];
double aa0_22[];
double aa0_23[];
double aa0_24[];
double aa0_25[];
double aa0_26[];
double aa0_27[];
double aa0_28[];
double aa0_29[];
double aa0_30[];
double aa0_31[];
double aa0_32[];
double aa0_33[];
double aa0_34[];
double aa0_35[];
double aa0_36[];
double aa0_37[];
double aa0_38[];
double aa0_39[];
double aa0_40[];
double aa0_41[];
double aa0_42[];
double aa0_43[];
double aa0_44[];
//double aa0_45[];
//double aa0_46[];
//double aa0_47[];
//double aa0_48[];
//double aa0_49[];
//double aa0_50[];
//double aa0_51[];
//double aa0_52[];
//double aa0_53[];
//double aa0_54[];
//double aa0_55[];
//double aa0_56[];
//double aa0_57[];
//double aa0_58[];
//double aa0_59[];


double aa1[];
double aa2[];
double aa3[];
double aa4[];
double aa5[];
double aa6[];
double aa7[];
double aa8[];
double aa9[];
double aa10[];
double aa11[];
double aa12[];
double aa13[];
double aa14[];
double aa15[];
double aa16[];
double aa17[];
double aa18[];
double aa19[];
double aa20[];
double aa21[];
double aa22[];
double aa23[];
double aa24[];
double aa25[];
double aa26[];
double aa27[];
double aa28[];
double aa29[];
double aa30[];
double aa31[];
double aa32[];
double aa33[];
double aa34[];
double aa35[];
double aa36[];
double aa37[];
double aa38[];
double aa39[];
double aa40[];
double aa41[];
double aa42[];
double aa43[];
double aa44[];
//double aa45[];
//double aa46[];
//double aa47[];
//double aa48[];
//double aa49[];
//double aa50[];
//double aa51[];
//double aa52[];
//double aa53[];
//double aa54[];
//double aa55[];
//double aa56[];
//double aa57[];
//double aa58[];
//double aa59[];


int N;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
SetIndexBuffer(0,Buffer1);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Buffer2);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,Buffer3);
SetIndexStyle(3,DRAW_LINE);
SetIndexBuffer(3,Buffer4);
SetIndexStyle(4,DRAW_LINE);
SetIndexBuffer(4,Buffer5);
SetIndexStyle(5,DRAW_LINE);
SetIndexBuffer(5,Buffer6);
SetIndexStyle(6,DRAW_LINE);
SetIndexBuffer(6,Buffer7);
SetIndexStyle(7,DRAW_LINE);
SetIndexBuffer(7,Buffer8);



//---
   N=MathPow(2,n);
   ArrayResize(aa0,N);
   ArrayResize(aa0_1,N);
   ArrayResize(aa0_2,N);
   ArrayResize(aa0_3,N);
   ArrayResize(aa0_4,N);
   ArrayResize(aa0_5,N);
   ArrayResize(aa0_6,N);
   ArrayResize(aa0_7,N);
   ArrayResize(aa0_8,N);
   ArrayResize(aa0_9,N);
   ArrayResize(aa0_10,N);
   ArrayResize(aa0_11,N);
   ArrayResize(aa0_12,N);
   ArrayResize(aa0_13,N);
   ArrayResize(aa0_14,N);
   ArrayResize(aa0_15,N);
   ArrayResize(aa0_16,N);
   ArrayResize(aa0_17,N);
   ArrayResize(aa0_18,N);
   ArrayResize(aa0_19,N);
   ArrayResize(aa0_20,N);
   ArrayResize(aa0_21,N);
   ArrayResize(aa0_22,N);
   ArrayResize(aa0_23,N);
   ArrayResize(aa0_24,N);
   ArrayResize(aa0_25,N);
   ArrayResize(aa0_26,N);
   ArrayResize(aa0_27,N);
   ArrayResize(aa0_28,N);
   ArrayResize(aa0_29,N);
   ArrayResize(aa0_30,N);
   ArrayResize(aa0_31,N);
   ArrayResize(aa0_32,N);
   ArrayResize(aa0_33,N);
   ArrayResize(aa0_34,N);
   ArrayResize(aa0_35,N);
   ArrayResize(aa0_36,N);
   ArrayResize(aa0_37,N);
   ArrayResize(aa0_38,N);
   ArrayResize(aa0_39,N);
   ArrayResize(aa0_40,N);
   ArrayResize(aa0_41,N);
   ArrayResize(aa0_42,N);
   ArrayResize(aa0_43,N);
   ArrayResize(aa0_44,N);
//   ArrayResize(aa0_45,N);
//   ArrayResize(aa0_46,N);
//   ArrayResize(aa0_47,N);
//   ArrayResize(aa0_48,N);
//   ArrayResize(aa0_49,N);
//   ArrayResize(aa0_50,N);
//   ArrayResize(aa0_51,N);
//   ArrayResize(aa0_52,N);
//   ArrayResize(aa0_53,N);
//   ArrayResize(aa0_54,N);
//   ArrayResize(aa0_55,N);
//   ArrayResize(aa0_56,N);
//   ArrayResize(aa0_57,N);
//   ArrayResize(aa0_58,N);
//   ArrayResize(aa0_59,N);
   
   

   ArrayResize(aa1,N);
   ArrayResize(aa2,N);
   ArrayResize(aa3,N);
   ArrayResize(aa4,N);
   ArrayResize(aa5,N);
   ArrayResize(aa6,N);
   ArrayResize(aa7,N);
   ArrayResize(aa8,N);
   ArrayResize(aa9,N);
   ArrayResize(aa10,N);
   ArrayResize(aa11,N);
   ArrayResize(aa12,N);
   ArrayResize(aa13,N);                                    
   ArrayResize(aa14,N);
   ArrayResize(aa15,N);
   ArrayResize(aa16,N);
   ArrayResize(aa17,N);
   ArrayResize(aa18,N);
   ArrayResize(aa19,N);
   ArrayResize(aa20,N);
   ArrayResize(aa21,N);
   ArrayResize(aa22,N);
   ArrayResize(aa23,N);
   ArrayResize(aa24,N);
   ArrayResize(aa25,N);
   ArrayResize(aa26,N);                                    
   ArrayResize(aa27,N);
   ArrayResize(aa28,N);
   ArrayResize(aa29,N);
   ArrayResize(aa30,N);
   ArrayResize(aa31,N);
   ArrayResize(aa32,N);
   ArrayResize(aa33,N);
   ArrayResize(aa34,N);
   ArrayResize(aa35,N);
   ArrayResize(aa36,N);
   ArrayResize(aa37,N);
   ArrayResize(aa38,N);
   ArrayResize(aa39,N);                                    
   ArrayResize(aa40,N);
   ArrayResize(aa41,N);
   ArrayResize(aa42,N);
   ArrayResize(aa43,N);
   ArrayResize(aa44,N);
//   ArrayResize(aa45,N);
//   ArrayResize(aa46,N);
//   ArrayResize(aa47,N);
//   ArrayResize(aa48,N);
//   ArrayResize(aa49,N);
//   ArrayResize(aa50,N);
//  ArrayResize(aa51,N);
//   ArrayResize(aa52,N);                                    
//   ArrayResize(aa53,N);
//   ArrayResize(aa54,N);
//   ArrayResize(aa55,N);
//   ArrayResize(aa56,N);
//   ArrayResize(aa57,N);
//   ArrayResize(aa58,N);
//   ArrayResize(aa59,N);

if( Fmax>=N ) Fmax=N;
if( Fmin<=2 ) Fmin=2;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   if( Bars<N) return(0);
   RefreshRates();
   //---
   for(int i=N-1; i>=0; i--) 
   { 
     aa1[i]=iClose(Symb1,0,i); 
     aa2[i]=iClose(Symb2,0,i); 
     aa3[i]=iClose(Symb3,0,i); 
     aa4[i]=iClose(Symb4,0,i); 
     aa5[i]=iClose(Symb5,0,i); 
     aa6[i]=iClose(Symb6,0,i); 
     aa7[i]=iClose(Symb7,0,i); 
     aa8[i]=iClose(Symb8,0,i); 
     aa9[i]=iClose(Symb9,0,i); 
     aa10[i]=iClose(Symb10,0,i); 
     aa11[i]=iClose(Symb11,0,i); 
     aa12[i]=iClose(Symb12,0,i); 
     aa13[i]=iClose(Symb13,0,i); 
     aa14[i]=iClose(Symb14,0,i); 
     aa15[i]=iClose(Symb15,0,i); 
     aa16[i]=iClose(Symb16,0,i); 
     aa17[i]=iClose(Symb17,0,i); 
     aa18[i]=iClose(Symb18,0,i); 
     aa19[i]=iClose(Symb19,0,i); 
     aa20[i]=iClose(Symb20,0,i); 
     aa21[i]=iClose(Symb21,0,i); 
     aa22[i]=iClose(Symb22,0,i); 
     aa23[i]=iClose(Symb23,0,i); 
     aa24[i]=iClose(Symb24,0,i); 
     aa25[i]=iClose(Symb25,0,i); 
     aa26[i]=iClose(Symb26,0,i); 
     aa27[i]=iClose(Symb27,0,i); 
     aa28[i]=iClose(Symb28,0,i); 
     aa29[i]=iClose(Symb29,0,i); 
     aa30[i]=iClose(Symb30,0,i); 
     aa31[i]=iClose(Symb31,0,i); 
     aa32[i]=iClose(Symb32,0,i); 
     aa33[i]=iClose(Symb33,0,i); 
     aa34[i]=iClose(Symb34,0,i); 
     aa35[i]=iClose(Symb35,0,i); 
     aa36[i]=iClose(Symb36,0,i); 
     aa37[i]=iClose(Symb37,0,i); 
     aa38[i]=iClose(Symb38,0,i); 
     aa39[i]=iClose(Symb39,0,i); 
     aa40[i]=iClose(Symb40,0,i); 
     aa41[i]=iClose(Symb41,0,i); 
     aa42[i]=iClose(Symb42,0,i); 
     aa43[i]=iClose(Symb43,0,i); 
     aa44[i]=iClose(Symb44,0,i); 
//     aa45[i]=iClose(Symb45,0,i); 
//     aa46[i]=iClose(Symb46,0,i); 
//     aa47[i]=iClose(Symb47,0,i); 
//     aa48[i]=iClose(Symb48,0,i); 
//     aa49[i]=iClose(Symb49,0,i); 
//     aa50[i]=iClose(Symb50,0,i); 
//     aa51[i]=iClose(Symb51,0,i); 
//     aa52[i]=iClose(Symb52,0,i); 
//     aa53[i]=iClose(Symb53,0,i); 
//     aa54[i]=iClose(Symb54,0,i); 
//     aa55[i]=iClose(Symb55,0,i); 
//     aa56[i]=iClose(Symb56,0,i); 
//     aa57[i]=iClose(Symb57,0,i); 
//    aa58[i]=iClose(Symb58,0,i); 
//     aa59[i]=iClose(Symb59,0,i); 
     
     

   }
   //---
   
   InSigNormalize(aa1);
   InSigNormalize(aa2);
   InSigNormalize(aa3);
   InSigNormalize(aa4);
   InSigNormalize(aa5);
   InSigNormalize(aa6);
   InSigNormalize(aa7);
   InSigNormalize(aa8);
   InSigNormalize(aa9);
   InSigNormalize(aa10);
   InSigNormalize(aa11);
   InSigNormalize(aa12);
   InSigNormalize(aa13);
   InSigNormalize(aa14);
   InSigNormalize(aa15);
   InSigNormalize(aa16);
   InSigNormalize(aa17);
   InSigNormalize(aa18);
   InSigNormalize(aa19);
   InSigNormalize(aa20);
   InSigNormalize(aa21);
   InSigNormalize(aa22);
   InSigNormalize(aa23);
   InSigNormalize(aa24);
   InSigNormalize(aa25);
   InSigNormalize(aa26);
   InSigNormalize(aa27);
   InSigNormalize(aa28);
   InSigNormalize(aa29);
   InSigNormalize(aa30);
   InSigNormalize(aa31);
   InSigNormalize(aa32);
   InSigNormalize(aa33);
   InSigNormalize(aa34);
   InSigNormalize(aa35);
   InSigNormalize(aa36);
   InSigNormalize(aa37);
   InSigNormalize(aa38);
   InSigNormalize(aa39);
   InSigNormalize(aa40);
   InSigNormalize(aa41);
   InSigNormalize(aa42);
   InSigNormalize(aa43);
   InSigNormalize(aa44);
//   InSigNormalize(aa45);
//   InSigNormalize(aa46);
//   InSigNormalize(aa47);
//   InSigNormalize(aa48);
//   InSigNormalize(aa49);
//   InSigNormalize(aa50);
//   InSigNormalize(aa51);
//   InSigNormalize(aa52);
//   InSigNormalize(aa53);
//   InSigNormalize(aa54);
//   InSigNormalize(aa55);
//   InSigNormalize(aa56);
//   InSigNormalize(aa57);
//   InSigNormalize(aa58);
//   InSigNormalize(aa59);
   
   
   realfastfouriertransform(aa1, N, false);
   realfastfouriertransform(aa2, N, false);
   realfastfouriertransform(aa3, N, false);
   realfastfouriertransform(aa4, N, false);
   realfastfouriertransform(aa5, N, false);
   realfastfouriertransform(aa6, N, false);
   realfastfouriertransform(aa7, N, false);
   realfastfouriertransform(aa8, N, false);
   realfastfouriertransform(aa9, N, false);
   realfastfouriertransform(aa10, N, false);
   realfastfouriertransform(aa11, N, false);
   realfastfouriertransform(aa12, N, false);
   realfastfouriertransform(aa13, N, false);
   realfastfouriertransform(aa14, N, false);
   realfastfouriertransform(aa15, N, false);
   realfastfouriertransform(aa16, N, false);
   realfastfouriertransform(aa17, N, false);
   realfastfouriertransform(aa18, N, false);
   realfastfouriertransform(aa19, N, false);
   realfastfouriertransform(aa20, N, false);
   realfastfouriertransform(aa21, N, false);
   realfastfouriertransform(aa22, N, false);
   realfastfouriertransform(aa23, N, false);
   realfastfouriertransform(aa24, N, false);
   realfastfouriertransform(aa25, N, false);
   realfastfouriertransform(aa26, N, false);
   realfastfouriertransform(aa27, N, false);
   realfastfouriertransform(aa28, N, false);
   realfastfouriertransform(aa29, N, false);
   realfastfouriertransform(aa30, N, false);
   realfastfouriertransform(aa31, N, false);
   realfastfouriertransform(aa32, N, false);
   realfastfouriertransform(aa33, N, false);
   realfastfouriertransform(aa34, N, false);
   realfastfouriertransform(aa35, N, false);
   realfastfouriertransform(aa36, N, false);
   realfastfouriertransform(aa37, N, false);
   realfastfouriertransform(aa38, N, false);
   realfastfouriertransform(aa39, N, false);
   realfastfouriertransform(aa40, N, false);
   realfastfouriertransform(aa41, N, false);
   realfastfouriertransform(aa42, N, false);
   realfastfouriertransform(aa43, N, false);
   realfastfouriertransform(aa44, N, false);
//   realfastfouriertransform(aa45, N, false);
//   realfastfouriertransform(aa46, N, false);
//   realfastfouriertransform(aa47, N, false);
//   realfastfouriertransform(aa48, N, false);
//   realfastfouriertransform(aa49, N, false);
//   realfastfouriertransform(aa50, N, false);
//   realfastfouriertransform(aa51, N, false);
//   realfastfouriertransform(aa52, N, false);
//   realfastfouriertransform(aa53, N, false);
//   realfastfouriertransform(aa54, N, false);
//   realfastfouriertransform(aa55, N, false);
//   realfastfouriertransform(aa56, N, false);
//   realfastfouriertransform(aa57, N, false);
//   realfastfouriertransform(aa58, N, false);
//   realfastfouriertransform(aa59, N, false);

   //---
   N=ArraySize(aa1);
   //Comment("n= ",N);
   //---
   for( i=0; i<=N-1; i++) 
   { 
      if( i<Fmin || i>Fmax) 
      { 
        aa1[i]=0.0; 
        aa2[i]=0.0; 
        aa3[i]=0.0; 
        aa4[i]=0.0; 
        aa5[i]=0.0; 
        aa6[i]=0.0; 
        aa7[i]=0.0; 
        aa8[i]=0.0; 
        aa9[i]=0.0; 
        aa10[i]=0.0; 
        aa11[i]=0.0; 
        aa12[i]=0.0; 
        aa13[i]=0.0;                                                                                                 
        aa14[i]=0.0; 
        aa15[i]=0.0; 
        aa16[i]=0.0; 
        aa17[i]=0.0; 
        aa18[i]=0.0; 
        aa19[i]=0.0; 
        aa20[i]=0.0; 
        aa21[i]=0.0; 
        aa22[i]=0.0; 
        aa23[i]=0.0; 
        aa24[i]=0.0; 
        aa25[i]=0.0; 
        aa26[i]=0.0;                                                                                                 
        aa27[i]=0.0; 
        aa28[i]=0.0; 
        aa29[i]=0.0; 
        aa30[i]=0.0; 
        aa31[i]=0.0; 
        aa32[i]=0.0; 
        aa33[i]=0.0; 
        aa34[i]=0.0; 
        aa35[i]=0.0; 
        aa36[i]=0.0; 
        aa37[i]=0.0; 
        aa38[i]=0.0; 
        aa39[i]=0.0;                                                                                                 
        aa40[i]=0.0; 
        aa41[i]=0.0; 
        aa42[i]=0.0; 
        aa43[i]=0.0; 
        aa44[i]=0.0; 
/*        aa45[i]=0.0; 
        aa46[i]=0.0; 
        aa47[i]=0.0; 
        aa48[i]=0.0; 
        aa49[i]=0.0; 
        aa50[i]=0.0; 
        aa51[i]=0.0; 
        aa52[i]=0.0;                                                                                                 
        aa53[i]=0.0; 
        aa54[i]=0.0; 
        aa55[i]=0.0; 
        aa56[i]=0.0; 
        aa57[i]=0.0; 
        aa58[i]=0.0; 
        aa59[i]=0.0; 
*/
      }
      aa0[i]=aa1[i]+
             aa2[i]+
             aa3[i]+
             aa4[i]+
             aa5[i]+
             aa6[i]+
             aa7[i]+
             aa8[i]+
             aa8[i]+
             aa9[i]+
             aa10[i]+
             aa11[i]+
             aa12[i]+
             aa13[i]+
             aa14[i]+
             aa15[i]+
             aa16[i]+
             aa17[i]+
             aa18[i]+
             aa19[i]+
             aa20[i]+
             aa21[i]+
             aa22[i]+
             aa23[i]+
             aa24[i]+
             aa25[i]+
             aa26[i]+
             aa27[i]+
             aa28[i]+
             aa29[i]+
             aa30[i]+
             aa31[i]+
             aa32[i]+
             aa33[i]+
             aa34[i]+
             aa35[i]+
             aa36[i]+
             aa37[i]+
             aa38[i]+
             aa39[i]+
             aa40[i]+
             aa41[i]+
             aa42[i]+
             aa43[i]+
             aa44[i];
/*             aa45[i]+
             aa46[i]+
             aa47[i]+
             aa48[i]+
             aa49[i]+
             aa50[i]+
             aa51[i]+
             aa52[i]+
             aa53[i]+
             aa54[i]+
             aa55[i]+
             aa56[i]+
             aa57[i]+
             aa58[i]+
             aa59[i];
*/
      //aa0_1[i]=aa1[i];
      //aa0_2[i]=aa2[i];
      //aa0_3[i]=aa3[i];
      //aa0_4[i]=aa4[i];
      //aa0_5[i]=aa5[i];
      //aa0_6[i]=aa6[i];
      //aa0_7[i]=aa7[i];      
      
   }
   //---
   //InSigNormalize(aa0);
   //InSigNormalize(aa0_buy);
   //InSigNormalize(aa0_sell);
   
   realfastfouriertransform(aa0, N, true);
   //realfastfouriertransform(aa0_1, N, true);
   //realfastfouriertransform(aa0_2, N, true);
   //realfastfouriertransform(aa0_3, N, true);
   //realfastfouriertransform(aa0_4, N, true);
   //realfastfouriertransform(aa0_5, N, true);
   //realfastfouriertransform(aa0_6, N, true);
   //realfastfouriertransform(aa0_7, N, true);
   
   //---
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   SetIndexDrawBegin(2,Bars-N);
   SetIndexDrawBegin(3,Bars-N);
   SetIndexDrawBegin(4,Bars-N);
   SetIndexDrawBegin(5,Bars-N);
   SetIndexDrawBegin(6,Bars-N);
   SetIndexDrawBegin(7,Bars-N);

   //---
   double x1[20];
   double y1[20];
   for( i=0; i<=N-1; i++)
   {
      Buffer1[i]=aa0[i];
      //Buffer2[i]=aa0_1[i];
      //Buffer3[i]=aa0_2[i];
      //Buffer4[i]=aa0_3[i];
      //Buffer5[i]=aa0_4[i];
      //Buffer6[i]=aa0_5[i];
      //Buffer7[i]=aa0_6[i];
      //Buffer8[i]=aa0_7[i];      

      /*
      for (int j=0;j<pearson_per;j++)
      {
        x1[j]= Buffer2[i+j];
        y1[j]= Buffer3[i+j];
      }  
      Buffer4[i]=pearson( x1,y1)/10;
      //Buffer4[i]=CorrelationIND(Buffer2,Buffer3,20,i)/100;
      */
   }
   //----
   return(0);
  }
//-------------------------------------------------------------------+
//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}
//---------------------------------------------------------------------+
//---------------------------------------------------------------------+
//int cPeriod=20
double CorrelationIND(double Symbol1[],double Symbol2[],int cPeriod,int CorrelationShift=0){
   double Correlation[],DiffBuffer1[],DiffBuffer2[],PowDiff1[],PowDiff2[];
   ArrayResize(Correlation,cPeriod*2);ArrayResize(DiffBuffer1,cPeriod*2);
   ArrayResize(DiffBuffer2,cPeriod*2);ArrayResize(PowDiff1,cPeriod*2);ArrayResize(PowDiff2,cPeriod*2);
   for( int shift=cPeriod+1; shift>=0; shift--){
      DiffBuffer1[shift]=Symbol1[shift];//iClose(Symbol1,0,shift)-iMA(Symbol1,0,cPeriod,0,MODE_SMA,PRICE_CLOSE,shift);
      DiffBuffer2[shift]=Symbol2[shift];//iClose(Symbol2,0,shift)-iMA(Symbol2,0,cPeriod,0,MODE_SMA,PRICE_CLOSE,shift);
      PowDiff1[shift]=MathPow(DiffBuffer1[shift],2);
      PowDiff2[shift]=MathPow(DiffBuffer2[shift],2);
      double u=0,l=0,s=0;
      for( int i = cPeriod-1 ;i >= 0 ;i--){
         u += DiffBuffer1[shift+i]*DiffBuffer2[shift+i];
         l += PowDiff1[shift+i];
         s += PowDiff2[shift+i];
      }
      if(l*s >0)Correlation[shift]=u/MathSqrt(l*s);
   }   
   return(Correlation[CorrelationShift]);
   return(-1); 
}

double pearson( double x[], double y[])
{
  int i,j;
  double sxy,sx,sx2,sy,sy2,a,b,c,r;
  int n1 = ArraySize(x);
  for(i=0; i<n1; i++)
  {
    sxy+=x[i]*y[i];
    sx+=x[i];
    sx2+=x[i]*x[i];
    sy+=y[i];
    sy2+=y[i]*y[i];   
  }
  a=sxy-sx*sy/n1;
  b=sx2-sx*sx/n1;
  c=sy2-sy*sy/n1;
  r=a/MathSqrt(b*c);
  return(r);
}